<?php
namespace Teknisa\GOP\Modules\Parametro\Controllers; 

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification; 

class Gop00100OrcamentoOperacionalController extends \Teknisa\GER\Controllers\TeknisaCrud{
    
    protected $crudService;
    protected $connection;
    protected $environment;
    
    public function __construct($crudService, ParameterBag $parameterBag, $connection, $environment) {
        $this->connection = $connection;
        $this->environment = $environment;
        parent::__construct($crudService, $parameterBag);
    }
    public function atualizaFilial(DTO\Request $request, DTO\Response $response){
        
        $rows    = $request->getParameter("dataset");
        
        if($rows != null){
            
            try{
                foreach($rows as $row){
                    if(!empty($row["NMFILIAL"])){
                        foreach ($row["NMFILIAL"] as $value) {
                            $stmt = $this->connection->prepare(
                            "UPDATE FILIAL
                                    SET
                                        NRMESREAJCONTR     = NVL(:P_NRMESREAJCONTR_NOVO,NRMESREAJCONTR),
                                        IDCONSAFORCFIL     = NVL(:P_IDCONSAFORCFIL_NOVO, IDCONSAFORCFIL),
                                        VRPEORCALERTFIL    = NVL(:P_VRPEORCALERTFIL_NOVO, VRPEORCALERTFIL),
                                        VRPEORCBLOQFIL     = NVL(:P_VRPEORCBLOQFIL_NOVO, VRPEORCBLOQFIL),
                                        IDCALCOMESTORC     = NVL(:P_IDCALCOMESTORC_NOVO, IDCALCOMESTORC),
                                        NRDIAINIORCAGOP    = NVL(:P_NRDIAINIORCAGOP_NOVO, NRDIAINIORCAGOP),
                                        CDOPERULTATU    = :P_CDOPERULTATU
                                    WHERE
                                        CDFILIAL = :P_CDFILIAL"
                            );
                            $stmt->execute(
                                array(
                                    'P_NRMESREAJCONTR_NOVO'  => $row["NRMESREAJCONTR"],
                                    'P_IDCONSAFORCFIL_NOVO'  => $row["IDCONSAFORCFIL"],
                                    'P_VRPEORCALERTFIL_NOVO' => $row["VRPEORCALERTFIL"],
                                    'P_VRPEORCBLOQFIL_NOVO'  => $row["VRPEORCBLOQFIL"],
                                    'P_IDCALCOMESTORC_NOVO'  => $row["IDCALCOMESTORC"],
                                    'P_NRDIAINIORCAGOP_NOVO' => $row["NRDIAINIORCAGOP"],
                                    'P_CDOPERULTATU' => $this->environment->getCdOperador(),
                                    'P_CDFILIAL' => $value
                                )
                            );
                        }
                    }
                   
                }
            }catch(\Exception $ex){
                    $response->setError(new Error($ex->getMessage(), 500));
            }
        }

    }

}